(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/cdk/portal'), require('@angular/core'), require('rxjs'), require('rxjs/operators'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('angular-walkthrough', ['exports', '@angular/cdk/portal', '@angular/core', 'rxjs', 'rxjs/operators', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['angular-walkthrough'] = {}, global.ng.cdk.portal, global.ng.core, global.rxjs, global.rxjs.operators, global.ng.common));
}(this, (function (exports, portal, core, rxjs, operators, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from) {
        for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
            to[j] = from[i];
        return to;
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var WalkthroughText = /** @class */ (function () {
        function WalkthroughText() {
            this.previous = 'Previous';
            this.next = 'Next';
            this.close = 'Close';
        }
        return WalkthroughText;
    }());

    var booleanValue = function (value) {
        return value === 'true' || value === true;
    };
    var WalkthroughEvent = /** @class */ (function () {
        function WalkthroughEvent(component, focusElement) {
            this.component = component;
            this.focusElement = focusElement;
        }
        return WalkthroughEvent;
    }());
    var WalkthroughMargin = /** @class */ (function () {
        function WalkthroughMargin(top, right, bottom, left) {
            if (top === void 0) { top = 0; }
            this.top = top;
            this.right = right;
            this.bottom = bottom;
            this.left = left;
            if (right === undefined) {
                this.right = top;
            }
            if (bottom === undefined) {
                this.bottom = top;
            }
            if (left === undefined && right === undefined) {
                this.left = top;
            }
            else if (left === undefined) {
                this.left = right;
            }
        }
        WalkthroughMargin.parsePoints = function (points) {
            var pointsPx;
            if (points.match(/^\d+(?:\s+\d+)*$/)) {
                var split = points.split(/\s+/).map(function (i) { return parseFloat(i); });
                pointsPx = new WalkthroughMargin(split[0], split[1], split[2], split[3]);
            }
            return pointsPx || new WalkthroughMargin();
        };
        return WalkthroughMargin;
    }());

    var WalkthroughService = /** @class */ (function () {
        function WalkthroughService() {
            this._overflowRegex = /(auto|scroll)/;
        }
        WalkthroughService.prototype.retrieveCoordinates = function (element, margin) {
            var clientrect = element.getBoundingClientRect();
            var style = window.getComputedStyle(element);
            var coordinates = {
                top: clientrect.top - (margin ? margin.top : 0),
                height: clientrect.height,
                width: clientrect.width,
                left: clientrect.left - (margin ? margin.left : 0),
                margin: {
                    top: parseFloat(style.marginTop),
                    right: parseFloat(style.marginRight),
                    bottom: parseFloat(style.marginBottom),
                    left: parseFloat(style.marginLeft),
                }
            };
            coordinates.top += this.getTop();
            return coordinates;
        };
        WalkthroughService.prototype.getTop = function () {
            return window.pageYOffset || document.documentElement.scrollTop || document.body.scrollTop;
        };
        WalkthroughService.prototype.getDocumentHeight = function () {
            // Height of entire body : https://stackoverflow.com/a/1147768
            var body_height = Math.max(document.body.scrollHeight, document.body.offsetHeight, document.documentElement.clientHeight, document.documentElement.scrollHeight, document.documentElement.offsetHeight);
            return Math.max(this.getHeightOfPage() + this.getTop(), body_height);
        };
        WalkthroughService.prototype.scrollIntoViewIfOutOfView = function (element) {
            var topOfPage = this.getTop();
            var heightOfPage = this.getHeightOfPage();
            var elementY = 0;
            var elementH = 0;
            var parent = element;
            while (parent && parent !== document.body) {
                elementY += parent.offsetTop;
                parent = parent.offsetParent;
            }
            elementH = element.offsetHeight;
            if ((topOfPage + heightOfPage) < (elementY + elementH)) {
                element.scrollIntoView(false);
            }
            else if (elementY < topOfPage) {
                element.scrollIntoView(true);
                window.scrollBy(0, -30);
            }
            else {
                // test of overflow element
                var current = element;
                while (current && current !== document.body) {
                    parent = this.getScrollParent(current);
                    if (current.offsetTop + current.offsetHeight - parent.scrollTop > parent.offsetHeight ||
                        current.offsetLeft + current.offsetWidth - parent.scrollLeft > parent.offsetWidth) {
                        element.scrollIntoView();
                        window.scrollBy(0, -30);
                        break;
                    }
                    current = parent;
                }
            }
        };
        WalkthroughService.prototype.getScrollParent = function (element) {
            var scrollParent;
            var style = getComputedStyle(element);
            var excludeStaticParent = style.position === 'absolute';
            if (style.position !== 'fixed') {
                var parent = element.parentElement;
                while (parent && parent !== document.body) {
                    style = getComputedStyle(parent);
                    if (!(excludeStaticParent && style.position === 'static') &&
                        this._overflowRegex.test(style.overflow + style.overflowY + style.overflowX)) {
                        scrollParent = parent;
                        break;
                    }
                    parent = parent.parentElement;
                }
            }
            return scrollParent || document.body;
        };
        WalkthroughService.prototype.getHeightOfPage = function () {
            return window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
        };
        return WalkthroughService;
    }());
    WalkthroughService.decorators = [
        { type: core.Injectable }
    ];

    var nextUniqueId$1 = 0;
    var noInstanceWarn = 'No instance of walkthroughContainer.';
    var anoterWktOnGoing = 'Another walkthrough is ongoing. Please close it before opening a new one.';
    var WalkthroughComponent = /** @class */ (function () {
        function WalkthroughComponent(_componentFactoryResolver, _applicationRef, _injector, _renderer, _walkthroughService) {
            var _this = this;
            this._componentFactoryResolver = _componentFactoryResolver;
            this._applicationRef = _applicationRef;
            this._injector = _injector;
            this._renderer = _renderer;
            this._walkthroughService = _walkthroughService;
            this.closed = new core.EventEmitter();
            this.finished = new core.EventEmitter();
            this.ready = new core.EventEmitter();
            this.typeSelector = 'element';
            this.contentStyle = 'draken';
            this.animation = 'none';
            this.animationDelays = 0;
            this.scrollOnTarget = true;
            this._uid = "walkthrough-" + nextUniqueId$1++;
            this._readyHasBeenEmited = false;
            this._display = false;
            this._hasHighlightAnimation = false;
            this._hasBackdrop = false;
            this._hasGlow = false;
            this._hasFinish = false;
            this._hasArrow = false;
            this._hasCloseButton = false;
            this._hasCloseAnywhere = true;
            this._disabled = false;
            this._marginZonePx = new WalkthroughMargin();
            this._alignContent = 'left';
            this._verticalAlignContent = 'top';
            this._contentSpacing = 0;
            this._verticalContentSpacing = 50;
            this._onContainerInit = new rxjs.Subject();
            this._onResize = new rxjs.Subject();
            this._onResize.pipe(operators.debounceTime(200)).subscribe(function () {
                var _a, _b;
                var instance = _this._getInstance();
                if ((instance === null || instance === void 0 ? void 0 : instance.ongoing) && _this._display && !((_b = (_a = WalkthroughComponent._walkthroughContainer) === null || _a === void 0 ? void 0 : _a.instance) === null || _b === void 0 ? void 0 : _b.pause)) {
                    _this._elementLocations();
                    setTimeout(function () {
                        _this._elementLocations();
                    }, 200);
                }
            });
        }
        Object.defineProperty(WalkthroughComponent.prototype, "marginZone", {
            get: function () { return this._marginZone; },
            set: function (points) {
                if (this._marginZone !== points) {
                    if (points === null) {
                        this._marginZone = null;
                    }
                    this._marginZonePx = WalkthroughMargin.parsePoints(points);
                    if (this._marginZonePx !== null) {
                        this._marginZone = points;
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "arrowColor", {
            get: function () { return this._arrowColor; },
            set: function (color) {
                if (this._arrowColor !== color) {
                    this._arrowColor = color;
                    if (this._getInstance()) {
                        this._getInstance().arrowColor = this._arrowColor;
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "id", {
            get: function () { return this._id; },
            set: function (value) { this._id = value || this._uid; },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "alignContent", {
            get: function () {
                return this._alignContent;
            },
            set: function (value) {
                if (this._alignContent !== value) {
                    this._alignContent = value;
                    this._updateElementPositions(this._getInstance());
                }
                else {
                    this._alignContent = value;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "verticalAlignContent", {
            get: function () {
                return this._verticalAlignContent;
            },
            set: function (value) {
                if (this._verticalAlignContent !== value) {
                    this._verticalAlignContent = value;
                    this._updateElementPositions(this._getInstance());
                }
                else {
                    this._verticalAlignContent = value;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "contentSpacing", {
            get: function () {
                return this._contentSpacing;
            },
            set: function (value) {
                value = Math.max(WalkthroughComponent.minimalMargin, value);
                if (this._contentSpacing !== value) {
                    this._contentSpacing = value * 1;
                    this._updateElementPositions(this._getInstance());
                }
                else {
                    this._contentSpacing = value * 1;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "verticalContentSpacing", {
            get: function () {
                return this._verticalContentSpacing;
            },
            set: function (value) {
                value = Math.max(WalkthroughComponent.minimalMargin, value);
                if (this._verticalContentSpacing !== value) {
                    this._verticalContentSpacing = value * 1;
                    this._updateElementPositions(this._getInstance());
                }
                else {
                    this._verticalContentSpacing = value * 1;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "closeButton", {
            get: function () {
                return this._hasCloseButton;
            },
            set: function (value) {
                this._hasCloseButton = booleanValue(value);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "closeAnywhere", {
            get: function () {
                return this._hasCloseAnywhere;
            },
            set: function (value) {
                this._hasCloseAnywhere = booleanValue(value);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "showArrow", {
            get: function () {
                return this._hasArrow;
            },
            set: function (value) {
                this._hasArrow = booleanValue(value);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "finishButton", {
            get: function () {
                return this._hasFinish;
            },
            set: function (value) {
                this._hasFinish = booleanValue(value);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "focusHighlightAnimation", {
            get: function () {
                return this._hasHighlightAnimation;
            },
            set: function (value) {
                this._hasHighlightAnimation = booleanValue(value);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "focusBackdrop", {
            get: function () {
                return this._hasBackdrop;
            },
            set: function (value) {
                this._hasBackdrop = booleanValue(value);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "focusGlow", {
            get: function () {
                return this._hasGlow;
            },
            set: function (value) {
                this._hasGlow = booleanValue(value);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "disabled", {
            get: function () {
                return this._disabled;
            },
            set: function (value) {
                var _this = this;
                this._disabled = value;
                var instance = this._getInstance();
                if (instance) {
                    setTimeout(function () {
                        instance.hasPrevious = _this._hasPreviousStep(instance);
                        instance.hasNext = _this._hasNextStep(instance);
                        if (!instance.hasNext) {
                            instance.hasFinish = true;
                        }
                        else {
                            instance.hasFinish = instance.parent.finishButton;
                        }
                    }, 50);
                }
            },
            enumerable: false,
            configurable: true
        });
        WalkthroughComponent.walkthroughStop = function () {
            if (WalkthroughComponent._walkthroughContainer) {
                WalkthroughComponent._walkthroughContainer.instance.stop();
            }
        };
        WalkthroughComponent.walkthroughHasShow = function () {
            return WalkthroughComponent._walkthroughContainer
                ? WalkthroughComponent._walkthroughContainer.instance.show
                : false;
        };
        WalkthroughComponent.walkthroughHasPause = function () {
            return WalkthroughComponent._walkthroughContainer
                ? WalkthroughComponent._walkthroughContainer.instance.pause
                : false;
        };
        WalkthroughComponent.walkthroughContinue = function () {
            if (WalkthroughComponent._walkthroughContainer &&
                WalkthroughComponent._walkthroughContainer.instance.parent) {
                var visible = WalkthroughComponent._walkthroughContainer.instance.parent._checkVisibility();
                if (visible) {
                    WalkthroughComponent._walkthroughContainer.instance.continue();
                }
                else {
                    // we can't open the walkthrough anymore, the focusElementSelector is no more visible
                    // so we update the flag "ongoing"
                    WalkthroughComponent._walkthroughContainer.instance.ongoing = false;
                }
            }
        };
        WalkthroughComponent.walkthroughNext = function () {
            if (WalkthroughComponent._walkthroughContainer) {
                WalkthroughComponent._walkthroughContainer.instance.next();
            }
        };
        WalkthroughComponent.walkthroughPrevious = function () {
            if (WalkthroughComponent._walkthroughContainer) {
                WalkthroughComponent._walkthroughContainer.instance.previous();
            }
        };
        WalkthroughComponent.prototype.resize = function () {
            this._onResize.next();
        };
        WalkthroughComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            // init the Walkthrough element container
            if (!WalkthroughComponent._walkthroughContainer && !WalkthroughComponent._walkthroughContainerCreating) {
                WalkthroughComponent._walkthroughContainerCreating = true;
                setTimeout(function () {
                    WalkthroughComponent._walkthroughContainer =
                        _this._appendComponentToBody(WalkthroughContainerComponent);
                    _this._onContainerInit.next();
                });
            }
        };
        WalkthroughComponent.prototype.next = function (closedEvent, finishedEvent) {
            if (closedEvent) {
                this.closed = closedEvent;
            }
            if (finishedEvent) {
                this.finished = finishedEvent;
            }
            this.open();
        };
        WalkthroughComponent.prototype.refresh = function () {
            if (this._getInstance()) {
                if (!this._getInstance().ongoing) {
                    WalkthroughComponent.onRefresh.next(this);
                    this._elementLocations();
                }
                else {
                    console.warn(anoterWktOnGoing);
                }
            }
            else {
                console.warn(noInstanceWarn);
            }
        };
        WalkthroughComponent.prototype.open = function () {
            var _this = this;
            return new Promise(function (resolve) {
                if (_this._checkVisibility()) {
                    if (_this._getInstance()) {
                        resolve(_this._open());
                    }
                    else {
                        _this._onContainerInit.pipe(operators.first()).subscribe(function () {
                            if (_this._getInstance()) {
                                resolve(_this._open());
                            }
                            else {
                                console.warn(noInstanceWarn);
                                resolve(false);
                            }
                        });
                    }
                }
                else {
                    resolve(false);
                }
            });
        };
        /**
         * Do not use this method outside of the library
         */
        WalkthroughComponent.prototype.loadPrevioustStep = function () {
            var _this = this;
            setTimeout(function () {
                WalkthroughComponent.onNavigate.next({ previous: _this, next: _this.previousStep });
                WalkthroughComponent.onNavigatePrevious.next({ previous: _this, next: _this.previousStep });
                _this.previousStep._next(_this.closed, _this.finished);
            }, 0);
        };
        /**
         * Do not use this method outside of the library
         */
        WalkthroughComponent.prototype.loadNextStep = function () {
            var _this = this;
            setTimeout(function () {
                WalkthroughComponent.onNavigate.next({ previous: _this, next: _this.nextStep });
                WalkthroughComponent.onNavigateNext.next({ previous: _this, next: _this.nextStep });
                _this.nextStep._next(_this.closed, _this.finished);
            }, 0);
        };
        /**
         * Do not use this method outside of the library
         */
        WalkthroughComponent.prototype.hide = function (finishLink, closeWalkthrough) {
            var _this = this;
            if (finishLink === void 0) { finishLink = false; }
            if (closeWalkthrough === void 0) { closeWalkthrough = true; }
            this._display = false;
            // add CSS to focusElement
            if (this.focusElementCSSClass && this._focusElement) {
                this._renderer.removeClass(this._focusElement, this.focusElementCSSClass);
            }
            if (closeWalkthrough) {
                setTimeout(function () {
                    _this._getInstance().ongoing = false;
                    WalkthroughComponent.onClose.next(_this);
                    // emit closed event
                    _this.closed.emit(finishLink);
                    if (!_this.nextStep) {
                        // emit finished event
                        WalkthroughComponent.onFinish.next(_this);
                        _this.finished.emit(new WalkthroughEvent(_this, _this._focusElement));
                    }
                }, 20);
            }
        };
        WalkthroughComponent.prototype._checkVisibility = function () {
            var e_1, _c;
            if (this.focusElementSelector) {
                var elements = document.querySelectorAll(this.focusElementSelector);
                if (elements.length === 0) {
                    return false;
                }
                if (this.visibilityCallback) {
                    return this.visibilityCallback();
                }
                try {
                    for (var elements_1 = __values(elements), elements_1_1 = elements_1.next(); !elements_1_1.done; elements_1_1 = elements_1.next()) {
                        var el = elements_1_1.value;
                        if (el.offsetParent === null) {
                            return false;
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (elements_1_1 && !elements_1_1.done && (_c = elements_1.return)) _c.call(elements_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            }
            return true;
        };
        WalkthroughComponent.prototype._open = function () {
            if (!this._getInstance().ongoing) {
                this._getInstance().ongoing = true;
                WalkthroughComponent.onOpen.next(this);
                this._elementLocations();
                return true;
            }
            else {
                console.warn(anoterWktOnGoing);
                return false;
            }
        };
        WalkthroughComponent.prototype._show = function () {
            this._display = true;
        };
        WalkthroughComponent.prototype._next = function (closedEvent, finishedEvent) {
            if (closedEvent) {
                this.closed = closedEvent;
            }
            if (finishedEvent) {
                this.finished = finishedEvent;
            }
            var instance = this._getInstance();
            if (instance && instance.ongoing) {
                instance.ongoing = false;
            }
            this.open();
        };
        WalkthroughComponent.prototype._getInstance = function () {
            return WalkthroughComponent._walkthroughContainer
                ? WalkthroughComponent._walkthroughContainer.instance
                : null;
        };
        WalkthroughComponent.prototype._appendComponentToBody = function (component) {
            // create a component reference
            var componentRef = this._componentFactoryResolver.resolveComponentFactory(component).create(this._injector);
            // attach component to the appRef so that so that it will be dirty checked.
            this._applicationRef.attachView(componentRef.hostView);
            // get DOM element from component
            var domElem = componentRef.hostView.rootNodes[0];
            document.body.appendChild(domElem);
            return componentRef;
        };
        WalkthroughComponent.prototype._attachWalkthroughContent = function (componentOrTemplateRef, walkthroughContainer) {
            if (componentOrTemplateRef instanceof core.TemplateRef) {
                walkthroughContainer.attachTemplatePortal(new portal.TemplatePortal(componentOrTemplateRef, null));
            }
            else {
                walkthroughContainer.attachComponentPortal(new portal.ComponentPortal(componentOrTemplateRef));
            }
        };
        WalkthroughComponent.prototype._elementLocations = function () {
            this._getFocusElement();
            var element = this._focusElement;
            if (element) {
                if (this.scrollOnTarget) {
                    this._walkthroughService.scrollIntoViewIfOutOfView(element);
                }
                // if there is a root element defined (in some cases when position fixed is used, we need to scroll on it)
                if (this.rootElement) {
                    document.querySelector(this.rootElement).scrollIntoView(true);
                }
                this._offsetCoordinates = this._walkthroughService.retrieveCoordinates(element);
                if (this.typeSelector === 'zone') {
                    var offsetEndCoordinatesEnd = this._walkthroughService.retrieveCoordinates(this._focusElementEnd);
                    this._offsetCoordinates.height = offsetEndCoordinatesEnd.top
                        - this._offsetCoordinates.top
                        + offsetEndCoordinatesEnd.height;
                    this._offsetCoordinates.width = offsetEndCoordinatesEnd.left
                        - this._offsetCoordinates.left
                        + offsetEndCoordinatesEnd.width;
                }
            }
            else {
                this._offsetCoordinates = null;
            }
            this._setFocus();
        };
        /**
         *
         */
        WalkthroughComponent.prototype._getFocusElement = function () {
            var focusElements;
            try {
                focusElements = this.focusElementSelector
                    ? document.querySelectorAll(this.focusElementSelector)
                    : null;
            }
            catch (error) {
                console.error("#" + this.id + "@focusElementSelector: '" + this.focusElementSelector + "' is not a valid selector.\n", error);
            }
            // getting focus element
            if (focusElements && focusElements.length > 0) {
                if (focusElements.length > 1) {
                    // Multiple items fit selector, displaying first visible as focus item in 'element' mode
                    var l = focusElements.length;
                    for (var i = 0; i < l; i++) {
                        // offsetHeight not of 0 means visible
                        if (focusElements[i].offsetHeight) {
                            this._focusElement = focusElements[i];
                            i = focusElements.length;
                            break;
                        }
                    }
                    // if typeSelector is by zone, get also the last element
                    if (this.typeSelector === 'zone') {
                        for (var i = l - 1; i >= 0; i--) {
                            // offsetHeight not of 0 means visible
                            if (focusElements[i].offsetHeight) {
                                this._focusElementEnd = focusElements[i];
                                i = focusElements.length;
                                break;
                            }
                        }
                        // this the zone this just a unique element, change mode for 'element'
                        if (this._focusElement === this._focusElementEnd) {
                            this.typeSelector = 'element';
                        }
                    }
                }
                else {
                    this._focusElement = focusElements[0];
                    this.typeSelector = 'element';
                }
            }
            else {
                this._focusElement = null;
            }
        };
        /**
         * get instance, hightlight the focused element et show the template
         */
        WalkthroughComponent.prototype._setFocus = function () {
            var _this = this;
            var instance = this._getInstance();
            if (instance) {
                var scrollY_1 = window.pageXOffset;
                this._initStylingTemplate(instance);
                setTimeout(function () {
                    if (_this._focusElement && instance.zone) {
                        instance.marginZonePx = _this._marginZonePx;
                        instance.hightlightZone(_this._offsetCoordinates, scrollY_1 - window.pageXOffset, _this.animation, _this.animationDelays, _this._setFocusContinue.bind(_this));
                    }
                    else {
                        _this._setFocusContinue();
                    }
                }, 20);
            }
        };
        WalkthroughComponent.prototype._setFocusContinue = function () {
            var _this = this;
            var instance = this._getInstance();
            if (!this._display) {
                this._attachContentTemplate();
                this._initContentTemplate(instance);
            }
            setTimeout(function () {
                instance.hightlightZoneStyling(_this._focusElement);
                _this._updateElementPositions(instance);
            }, 0);
        };
        WalkthroughComponent.prototype._updateElementPositions = function (instance) {
            var _this = this;
            if (WalkthroughComponent._walkthroughContainer && this._getInstance()) {
                setTimeout(function () {
                    instance.contentBlockPosition(_this._offsetCoordinates, _this._alignContent, _this._verticalAlignContent, _this._contentSpacing, _this._verticalContentSpacing);
                    if (_this._focusElement !== null && _this._hasArrow) {
                        instance.arrowPosition(_this._offsetCoordinates);
                    }
                    // add CSS to focusElement
                    if (_this.focusElementCSSClass && _this._focusElement) {
                        _this._renderer.addClass(_this._focusElement, _this.focusElementCSSClass);
                    }
                    setTimeout(function () {
                        _this._getInstance().setHeight();
                        if (!_this._readyHasBeenEmited) {
                            _this._readyHasBeenEmited = true;
                            _this.ready.emit(new WalkthroughEvent(_this, _this._focusElement));
                        }
                        var contentBlockNative = instance.contentBlock.nativeElement;
                        var scrollPos;
                        if (_this._focusElement != null) {
                            var coordinatesContent = _this._walkthroughService.retrieveCoordinates(contentBlockNative);
                            var coordinatesFocus = _this._walkthroughService.retrieveCoordinates(_this._focusElement);
                            // is content + focus higher than window ?
                            if (coordinatesContent.height + coordinatesFocus.height > window.innerHeight) {
                                // we scroll on content
                                contentBlockNative.scrollIntoView(true);
                                // we offset the window half of the content height
                                if (coordinatesContent.top > coordinatesFocus.top) {
                                    // content below focusZone
                                    scrollPos = -(coordinatesContent.height / 2);
                                }
                                else {
                                    // content above focusZone
                                    scrollPos = +(coordinatesContent.height / 2);
                                }
                            }
                            else {
                                // scroll on element higher minus minimal margin
                                if (coordinatesContent.top > coordinatesFocus.top) {
                                    window.scrollTo(coordinatesFocus.left, coordinatesFocus.top);
                                    scrollPos = -WalkthroughComponent.minimalMargin;
                                }
                                else {
                                    contentBlockNative.scrollIntoView(true);
                                    scrollPos = -WalkthroughComponent.minimalMargin;
                                }
                            }
                        }
                        else {
                            // no focus zone, scroll on content minus margin
                            contentBlockNative.scrollIntoView(true);
                            scrollPos = -WalkthroughComponent.minimalMargin;
                        }
                        window.scrollBy(0, scrollPos);
                    }, 50);
                }, 0);
            }
        };
        /**
         * Attache the template in the contener, if a template is linked.
         */
        WalkthroughComponent.prototype._attachContentTemplate = function () {
            if (this.contentTemplate) {
                this._attachWalkthroughContent(this.contentTemplate, this._getInstance());
            }
        };
        /**
         * init a partof styles of the contenaire
         */
        WalkthroughComponent.prototype._initStylingTemplate = function (instance) {
            var hasHighlightZone = this._focusElement !== null;
            instance.parent = this;
            instance.open();
            instance.hasHighlightZone = hasHighlightZone;
            instance.hasClickable = hasHighlightZone && typeof this.focusClick === 'function';
            instance.hasHighlight = hasHighlightZone && this._hasHighlightAnimation;
            instance.hasBackdrop = this._hasBackdrop;
            instance.hasGlow = hasHighlightZone && this._hasGlow;
        };
        /**
         * init all datas of the contenaire
         */
        WalkthroughComponent.prototype._initContentTemplate = function (instance) {
            var hasHighlightZone = this._focusElement !== null;
            instance.hasPrevious = this._hasPreviousStep(instance);
            instance.hasNext = this._hasNextStep(instance);
            instance.hasCloseButton = this._hasCloseButton;
            instance.hasCloseAnywhere = this._hasCloseAnywhere;
            instance.hasFinish = this._hasFinish || !instance.hasNext;
            instance.hasArrow = hasHighlightZone && this._hasArrow;
            instance.arrowColor = this.arrowColor;
            instance.radius = this.radius;
            instance.marginZone = this._marginZone ? this._marginZone.replace(/(\d+)/g, '$1px') : null;
            instance.marginZonePx = this._marginZonePx;
            instance.contentText = this.contentText;
            instance.contentStyle = this.contentStyle;
            instance.text = this.texts
                ? Object.assign(Object.assign({}, new WalkthroughText()), this.texts) : new WalkthroughText();
            this._show();
        };
        /**
         * check if there is a previous step enabled
         */
        WalkthroughComponent.prototype._hasPreviousStep = function (instance) {
            if (instance.parent) {
                var current = instance.parent.previousStep;
                while (current) {
                    if (!current.disabled) {
                        return true;
                    }
                    current = current.previousStep;
                }
            }
            return false;
        };
        /**
         * check if there is a next step enabled
         */
        WalkthroughComponent.prototype._hasNextStep = function (instance) {
            if (instance.parent) {
                var current = instance.parent.nextStep;
                while (current) {
                    if (!current.disabled) {
                        return true;
                    }
                    current = current.nextStep;
                }
            }
            return false;
        };
        return WalkthroughComponent;
    }());
    WalkthroughComponent._walkthroughContainer = null;
    WalkthroughComponent._walkthroughContainerCreating = false;
    WalkthroughComponent.minimalMargin = 60;
    WalkthroughComponent.onOpen = new rxjs.Subject();
    WalkthroughComponent.onRefresh = new rxjs.Subject();
    WalkthroughComponent.onClose = new rxjs.Subject();
    WalkthroughComponent.onNavigate = new rxjs.Subject();
    WalkthroughComponent.onNavigatePrevious = new rxjs.Subject();
    WalkthroughComponent.onNavigateNext = new rxjs.Subject();
    WalkthroughComponent.onFinish = new rxjs.Subject();
    WalkthroughComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'ng-walkthrough',
                    template: ''
                },] }
    ];
    /** @nocollapse */
    WalkthroughComponent.ctorParameters = function () { return [
        { type: core.ComponentFactoryResolver },
        { type: core.ApplicationRef },
        { type: core.Injector },
        { type: core.Renderer2 },
        { type: WalkthroughService }
    ]; };
    WalkthroughComponent.propDecorators = {
        closed: [{ type: core.Output }],
        finished: [{ type: core.Output }],
        ready: [{ type: core.Output }],
        focusElementCSSClass: [{ type: core.Input }],
        rootElement: [{ type: core.Input }],
        focusElementSelector: [{ type: core.Input }],
        typeSelector: [{ type: core.Input }],
        focusClick: [{ type: core.Input }],
        radius: [{ type: core.Input }],
        previousStep: [{ type: core.Input }],
        nextStep: [{ type: core.Input }],
        texts: [{ type: core.Input }],
        contentTemplate: [{ type: core.Input }],
        contentText: [{ type: core.Input }],
        contentStyle: [{ type: core.Input }],
        marginZone: [{ type: core.Input }],
        arrowColor: [{ type: core.Input }],
        animation: [{ type: core.Input }],
        animationDelays: [{ type: core.Input }],
        id: [{ type: core.Input }],
        alignContent: [{ type: core.Input }],
        verticalAlignContent: [{ type: core.Input }],
        contentSpacing: [{ type: core.Input }],
        verticalContentSpacing: [{ type: core.Input }],
        closeButton: [{ type: core.Input }],
        closeAnywhere: [{ type: core.Input }],
        showArrow: [{ type: core.Input }],
        finishButton: [{ type: core.Input }],
        focusHighlightAnimation: [{ type: core.Input }],
        focusBackdrop: [{ type: core.Input }],
        focusGlow: [{ type: core.Input }],
        disabled: [{ type: core.Input }],
        scrollOnTarget: [{ type: core.Input }],
        visibilityCallback: [{ type: core.Input }],
        resize: [{ type: core.HostListener, args: ['window:resize',] }]
    };

    function throwWalkthroughContentAlreadyAttachedError() {
        throw Error('Attempting to attach walkthrough content after content is already attached');
    }
    var is_safari = /^((?!chrome|android).)*safari/i.test(navigator.userAgent);
    var WalkthroughContainerComponent = /** @class */ (function (_super) {
        __extends(WalkthroughContainerComponent, _super);
        function WalkthroughContainerComponent(viewContainerRef, _walkthroughService, _renderer, _el) {
            var _this = _super.call(this) || this;
            _this.viewContainerRef = viewContainerRef;
            _this._walkthroughService = _walkthroughService;
            _this._renderer = _renderer;
            _this._el = _el;
            _this.markerUrl = 'url(#wkt-arrow)';
            /* if a walkthrough is ongoing (paused or not) */
            _this.ongoing = false;
            _this.show = false;
            _this.pause = false;
            // highlight zone
            _this.hasHighlightZone = false;
            _this.hasHighlight = false;
            _this.hasBackdrop = false;
            _this.hasGlow = false;
            // navigate
            _this.hasPrevious = false;
            _this.hasNext = false;
            _this.hasFinish = false;
            _this.hasCloseButton = false;
            _this.hasCloseAnywhere = true;
            // arrow
            _this.hasArrow = false;
            _this.arrowMarkerDist = 7;
            _this.marginZonePx = new WalkthroughMargin();
            // texts change / i18n
            _this.text = new WalkthroughText();
            return _this;
        }
        Object.defineProperty(WalkthroughContainerComponent.prototype, "id", {
            // HostBinding
            get: function () {
                return this.parent ? this.parent.id + '-container' : null;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WalkthroughContainerComponent.prototype, "hide", {
            get: function () {
                return !this.show;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WalkthroughContainerComponent.prototype, "cursor", {
            get: function () {
                return this.hasCloseAnywhere;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WalkthroughContainerComponent.prototype, "backdrop", {
            get: function () {
                return !this.hasHighlightZone && this.hasBackdrop;
            },
            enumerable: false,
            configurable: true
        });
        WalkthroughContainerComponent.prototype.click = function () {
            if (this.hasCloseAnywhere && this.show) {
                this.close();
            }
        };
        WalkthroughContainerComponent.prototype.clickZone = function (event) {
            if (this.parent && this.hasClickable) {
                this.parent.focusClick(event, this);
            }
        };
        /**
         * Attach a ComponentPortal as content to this walkthrough container.
         * @param portal Portal to be attached as the walkthrough content.
         */
        WalkthroughContainerComponent.prototype.attachComponentPortal = function (portal) {
            if (this._portalHost.hasAttached()) {
                throwWalkthroughContentAlreadyAttachedError();
            }
            // this._savePreviouslyFocusedElement();
            return this._portalHost.attachComponentPortal(portal);
        };
        /**
         * Attach a TemplatePortal as content to this walkthrough container.
         * @param portal Portal to be attached as the walkthrough content.
         */
        WalkthroughContainerComponent.prototype.attachTemplatePortal = function (portal) {
            if (this._portalHost.hasAttached()) {
                throwWalkthroughContentAlreadyAttachedError();
            }
            // this._savePreviouslyFocusedElement();
            return this._portalHost.attachTemplatePortal(portal);
        };
        WalkthroughContainerComponent.prototype.setHeight = function () {
            this._renderer.setStyle(this._el.nativeElement, 'height', this._walkthroughService.getDocumentHeight() + 'px');
        };
        WalkthroughContainerComponent.prototype.hightlightZone = function (coordinate, scrollDiff, animation, animationDelays, continueFunction) {
            var _this = this;
            var element = this.zone.nativeElement;
            var zoneStyle = element.style;
            var style = window.getComputedStyle(element, null);
            if (animation === 'linear' && animationDelays > 0 && style.left !== 'auto') {
                this.hideOther = true;
                var fragment_1 = 20;
                var intervale = animationDelays / fragment_1;
                var left_1 = parseInt(style.left, 10);
                var top_1 = scrollDiff + parseInt(style.top, 10);
                var width_1 = parseInt(style.width, 10);
                var height_1 = parseInt(style.height, 10);
                var partLeft_1 = (coordinate.left - left_1) / fragment_1;
                var partTop_1 = (coordinate.top - top_1) / fragment_1;
                var partWidth_1 = (coordinate.width - width_1) / fragment_1;
                var partHeight_1 = (coordinate.height - height_1) / fragment_1;
                var count_1 = 0;
                this.show = true;
                zoneStyle.borderRadius = '50%';
                var timer_1 = setInterval(function () {
                    zoneStyle.left = (left_1 + partLeft_1 * count_1) + 'px';
                    zoneStyle.top = (top_1 + partTop_1 * count_1) + 'px';
                    zoneStyle.width = (width_1 + partWidth_1 * count_1) + 'px';
                    zoneStyle.height = (height_1 + partHeight_1 * count_1) + 'px';
                    if (count_1++ >= fragment_1) {
                        clearInterval(timer_1);
                        _this.hideOther = false;
                        continueFunction();
                    }
                }, intervale);
            }
            else {
                zoneStyle.left = (coordinate.left - this.marginZonePx.left) + 'px';
                zoneStyle.top = (coordinate.top - this.marginZonePx.top) + 'px';
                zoneStyle.width = coordinate.width + 'px';
                zoneStyle.height = coordinate.height + 'px';
                continueFunction();
            }
        };
        WalkthroughContainerComponent.prototype.hightlightZoneStyling = function (element) {
            if (element) {
                var zoneStyle = this.zone.nativeElement.style;
                if (this.radius) {
                    if (Number(this.radius) === parseFloat(this.radius)) {
                        // if is numeric, change in %
                        zoneStyle.borderRadius = this.radius + '%';
                    }
                    else if (this.radius === 'auto') {
                        // if mode auto
                        var elementStyle = window.getComputedStyle(element, null);
                        // borderRadius work only on Chrome, use TopLeft, TopRight... for Firefox/Egde/IE
                        zoneStyle.borderTopLeftRadius = elementStyle.borderTopLeftRadius;
                        zoneStyle.borderTopRightRadius = elementStyle.borderTopRightRadius;
                        zoneStyle.borderBottomLeftRadius = elementStyle.borderBottomLeftRadius;
                        zoneStyle.borderBottomRightRadius = elementStyle.borderBottomRightRadius;
                    }
                    else {
                        // if is numeric, change in %
                        zoneStyle.borderRadius = this.radius;
                    }
                }
                else {
                    zoneStyle.borderRadius = '';
                }
            }
        };
        WalkthroughContainerComponent.prototype.contentBlockPosition = function (paramcoordinate, alignContent, verticalAlignContent, contentSpacing, verticalContentSpacing) {
            var element = this.contentBlock.nativeElement;
            var elementSize = this._walkthroughService.retrieveCoordinates(element);
            var width = elementSize.width + elementSize.margin.left + elementSize.margin.right;
            var height = elementSize.height + elementSize.margin.top + elementSize.margin.bottom;
            var coordinate = JSON.parse(JSON.stringify(paramcoordinate));
            coordinate.top -= this.marginZonePx.top;
            coordinate.left -= this.marginZonePx.left;
            coordinate.width += this.marginZonePx.left + this.marginZonePx.right;
            coordinate.height += this.marginZonePx.top + this.marginZonePx.bottom;
            // check if we've got the space to respect the alignContent attribute
            var notEnoughSpace = false;
            if (this.hasHighlightZone) {
                var spaceLeft = coordinate.left;
                var spaceRight = window.innerWidth - coordinate.left - coordinate.width;
                if (spaceLeft < width && spaceRight < width) {
                    notEnoughSpace = true;
                }
                // if not enough space to respect the alignContent, content goes above/below
                if ((verticalAlignContent === 'top' ||
                    verticalAlignContent === 'center' ||
                    verticalAlignContent === 'bottom') && !notEnoughSpace) {
                    // change align center to left or right if not enough space to align center
                    if (alignContent === 'center') {
                        var maxSpace = Math.max(spaceRight, spaceLeft);
                        if (maxSpace < width + ((window.innerWidth - width) / 2)) {
                            alignContent = spaceRight > spaceLeft ? 'right' : 'left';
                        }
                    }
                    else if (alignContent === 'left' && spaceLeft < width ||
                        alignContent === 'right' && spaceRight < width) {
                        verticalAlignContent = verticalAlignContent === 'bottom' || coordinate.top < height ? 'below' : 'above';
                    }
                }
            }
            // if not enough space on screen width, we center the content
            if (notEnoughSpace) {
                alignContent = 'center';
            }
            // position of content left/center/right
            element.style.right = '';
            element.style.left = '';
            if (alignContent === 'left') {
                element.style.left = '0';
                if (this.hasHighlightZone) {
                    var space = coordinate.left - width;
                    // handle contentSpacing
                    if (contentSpacing && space > contentSpacing) {
                        element.style.left = (coordinate.left -
                            width -
                            contentSpacing) + 'px';
                    }
                }
            }
            else if (alignContent === 'center') {
                element.style.left = (window.innerWidth / 2 - width / 2) + 'px';
            }
            else if (alignContent === 'right') {
                element.style.right = '0';
                if (this.hasHighlightZone) {
                    var space = window.innerWidth - coordinate.left - coordinate.width - width;
                    // handle contentSpacing
                    if (contentSpacing && space > contentSpacing) {
                        element.style.right = '';
                        element.style.left = (coordinate.left +
                            coordinate.width +
                            contentSpacing) + 'px';
                    }
                }
            }
            if (this.hasHighlightZone) {
                // for arrow position
                var startLeft = this._walkthroughService.retrieveCoordinates(element).left + width / 2;
                this._arrowPosition = startLeft > (coordinate.left - WalkthroughComponent.minimalMargin)
                    && startLeft < (coordinate.left + coordinate.width + WalkthroughComponent.minimalMargin)
                    ? 'topBottom' : 'leftRight';
                // if there is enough place on the left or on the right, we consider verticalAlignContent, otherwise, we ignore it
                if (verticalAlignContent && !notEnoughSpace) {
                    var space = 0;
                    this._contentPosition = verticalAlignContent;
                    switch (verticalAlignContent) {
                        case 'above':
                            space = coordinate.top;
                            if (space > verticalContentSpacing) {
                                element.style.top = (coordinate.top - height - verticalContentSpacing) + 'px';
                            }
                            else {
                                element.style.top = '0';
                            }
                            this._arrowPosition = 'topBottom';
                            break;
                        case 'top':
                            element.style.top = (coordinate.top) + 'px';
                            break;
                        case 'center':
                            element.style.top = (coordinate.top + (coordinate.height / 2) - (height / 2)) + 'px';
                            break;
                        case 'bottom':
                            element.style.top = (coordinate.top + coordinate.height - height) + 'px';
                            break;
                        case 'below':
                            space = this._walkthroughService.getDocumentHeight() - coordinate.top + coordinate.height;
                            if (space > verticalContentSpacing) {
                                element.style.top = (coordinate.top + coordinate.height + verticalContentSpacing) + 'px';
                            }
                            else {
                                element.style.top = (this._walkthroughService.getDocumentHeight() - height) + 'px';
                            }
                            this._arrowPosition = 'topBottom';
                            break;
                    }
                }
                else {
                    // position of content top/bottom
                    if (verticalAlignContent === 'below' || coordinate.top < height) {
                        element.style.top = (coordinate.top + coordinate.height + WalkthroughComponent.minimalMargin) + 'px';
                        this._contentPosition = 'below';
                    }
                    else {
                        element.style.top = (coordinate.top - height - WalkthroughComponent.minimalMargin) + 'px';
                        this._contentPosition = 'above';
                    }
                }
            }
            else {
                element.style.top = (this._walkthroughService.getHeightOfPage() / 2 - height / 2) + 'px';
            }
        };
        WalkthroughContainerComponent.prototype.arrowPosition = function (coordinate) {
            var contentBlockElement = this.contentBlock.nativeElement;
            var contentBlockCoordinates = this._walkthroughService.retrieveCoordinates(contentBlockElement);
            var realwidth = coordinate.width + this.marginZonePx.left + this.marginZonePx.right;
            var realheight = coordinate.height + this.marginZonePx.top + this.marginZonePx.bottom;
            // start point of the arrow (tail)
            var startLeft = contentBlockCoordinates.left + contentBlockCoordinates.width / 2;
            var startTop = contentBlockCoordinates.top + contentBlockCoordinates.height;
            // start point of the curve of the arrow
            var centerTop;
            var centerLeft;
            // end point of the arrow (head)
            var endLeft = coordinate.left - this.marginZonePx.left;
            var endTop = coordinate.top - this.marginZonePx.top;
            switch (this._contentPosition) {
                case 'top':
                case 'center':
                case 'bottom':
                    if (contentBlockCoordinates.left > coordinate.left) {
                        startLeft = contentBlockCoordinates.left;
                    }
                    else {
                        startLeft = contentBlockCoordinates.left + contentBlockCoordinates.width;
                    }
                    startTop -= contentBlockCoordinates.height / 2;
                    break;
                case 'below':
                    startTop -= contentBlockCoordinates.height;
                    break;
            }
            if (this._arrowPosition === 'topBottom') {
                endLeft += realwidth / 2;
                if (this._contentPosition === 'below') {
                    endTop += realheight + 6;
                }
                else {
                    endTop -= 6;
                }
                centerLeft = (startLeft + endLeft) / 2;
                centerTop = (startTop + endTop) / 2;
                // we make the curve start nearer the tail of the arrow
                if (startTop < centerTop) {
                    centerTop = centerTop - Math.abs(startTop - centerTop) / 2;
                }
                else {
                    centerTop = centerTop + Math.abs(startTop - centerTop) / 2;
                }
                this.arrowPath = "M" + startLeft + "," + startTop + " Q" + startLeft + "," + centerTop + " " + centerLeft + "," + centerTop + " "
                    + ("Q" + endLeft + "," + centerTop + " " + endLeft + "," + endTop);
            }
            else {
                if (startLeft > coordinate.left) {
                    endLeft += realwidth + this.arrowMarkerDist;
                }
                else {
                    endLeft -= this.arrowMarkerDist;
                }
                endTop += realheight / 2;
                centerLeft = (startLeft + endLeft) / 2;
                centerTop = (startTop + endTop) / 2;
                // we make the curve start nearer the tail of the arrow
                if (startLeft < centerLeft) {
                    centerLeft = centerLeft - Math.abs(startLeft - centerLeft) / 2;
                }
                else {
                    centerLeft = centerLeft + Math.abs(startLeft - centerLeft) / 2;
                }
                var directStartLeft = startLeft;
                var directStartTop = startTop;
                if (this._contentPosition === 'top' || this._contentPosition === 'bottom') {
                    directStartLeft = contentBlockCoordinates.left + (contentBlockCoordinates.width / 2);
                    directStartTop = (this._contentPosition === 'top') ?
                        (contentBlockCoordinates.top + contentBlockCoordinates.height) :
                        (contentBlockCoordinates.top);
                    // we use direct curve only if the arrow don't cross the content, otherwise, we use double curved
                    if ((this._contentPosition === 'top' && directStartTop < (endTop - WalkthroughComponent.minimalMargin)) ||
                        (this._contentPosition === 'bottom' && directStartTop > (endTop + WalkthroughComponent.minimalMargin))) {
                        this.arrowPath = "M" + directStartLeft + "," + directStartTop + " Q" + directStartLeft + "," + endTop + " " + endLeft + "," + endTop;
                    }
                    else {
                        this.arrowPath = "M" + startLeft + "," + startTop + " Q" + centerLeft + "," + startTop + " " + centerLeft + "," + centerTop + " "
                            + ("Q" + centerLeft + "," + endTop + " " + endLeft + "," + endTop);
                    }
                }
                else {
                    this.arrowPath = "M" + directStartLeft + "," + directStartTop + " Q" + directStartLeft + "," + endTop + " " + endLeft + "," + endTop;
                }
            }
        };
        /**
         * stop the walkthrough : hide the container and change to pause at true
         */
        WalkthroughContainerComponent.prototype.stop = function () {
            if (this.parent && !this.pause && this.show) {
                this.show = false;
                this.pause = true;
            }
        };
        /**
         * continue the walkthrough if is stopped : show the container and change to pause at false
         */
        WalkthroughContainerComponent.prototype.continue = function () {
            if (this.parent && this.pause) {
                this.show = true;
                this.pause = false;
                this.parent.refresh();
            }
        };
        WalkthroughContainerComponent.prototype.open = function () {
            // change markerUrl on Safari
            // related to
            // https://gist.github.com/leonderijke/c5cf7c5b2e424c0061d2
            // http://stackoverflow.com/a/18265336/796152
            // http://www.w3.org/TR/SVG/linking.html
            if (is_safari) {
                this.markerUrl = 'url(' + window.location.href + '#wkt-arrow)';
            }
            this.show = true;
        };
        WalkthroughContainerComponent.prototype.previous = function () {
            this.close(false, false);
            // we check if previous walkthrough is not disabled
            var current = this.parent;
            while (current) {
                if (current.previousStep && !current.previousStep.disabled) {
                    current.loadPrevioustStep();
                    return;
                }
                else {
                    if (!current.previousStep) {
                        break;
                    }
                    current = current.previousStep;
                }
            }
            // no more previous walkthrough enabled, we quit the walkthrough
            this.parent = current;
            this.close(true, true);
        };
        WalkthroughContainerComponent.prototype.next = function () {
            this.close(false, false);
            // we check if next walkthrough is not disabled
            var current = this.parent;
            while (current) {
                if (current.nextStep && !current.nextStep.disabled) {
                    current.loadNextStep();
                    return;
                }
                else {
                    if (!current.nextStep) {
                        break;
                    }
                    current = current.nextStep;
                }
            }
            // no more next walkthrough enabled, we quit the walkthrough
            this.parent = current;
            this.close(true, true);
        };
        WalkthroughContainerComponent.prototype.close = function (finishLink, closeWalkthrough) {
            if (finishLink === void 0) { finishLink = false; }
            if (closeWalkthrough === void 0) { closeWalkthrough = true; }
            // remove content
            this._portalHost.dispose();
            // hide
            this.show = false;
            if (this.parent) {
                this.parent.hide(finishLink, closeWalkthrough);
            }
        };
        return WalkthroughContainerComponent;
    }(portal.BasePortalHost));
    WalkthroughContainerComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'walkthrough-container',
                    template: "<div class=\"wkt-container\">\n    <div class=\"wkt-zone\"\n         #zone\n         (click)=\"clickZone($event)\"\n         [class.hide]=\"!hasHighlightZone\"\n         [class.backdrop]=\"hasBackdrop\"\n         [class.glow]=\"hasGlow\"\n         [class.clickable]=\"hasClickable\"\n         [class.highlight]=\"hasHighlight\"\n         [style.padding]=\"marginZone\"></div>\n    <div class=\"wkt-content-block\"\n         [class.hide]=\"hideOther\"\n         [class.darken]=\"contentStyle === 'draken'\"\n         #contentBlock>\n        <button type=\"button\"\n                class=\"wkt-close\"\n                *ngIf=\"hasCloseButton\"\n                (click)=\"close()\">\u2716</button>\n        <div class=\"wkt-content\">\n            <p *ngIf=\"contentText\">{{contentText}}</p>\n            <ng-template cdkPortalHost></ng-template>\n        </div>\n        <div class=\"wkt-navigate\"\n             *ngIf=\"hasPrevious||hasNext||hasFinish\">\n            <button type=\"button\"\n                    class=\"wkt-previous-link\"\n                    *ngIf=\"hasPrevious\"\n                    (click)=\"previous()\">{{text.previous}}</button>\n            <button type=\"button\"\n                    class=\"wkt-next-link\"\n                    *ngIf=\"hasNext\"\n                    (click)=\"next()\">{{text.next}}</button>\n            <button type=\"button\"\n                    class=\"wkt-finish-link\"\n                    *ngIf=\"hasFinish\"\n                    (click)=\"close(true)\">{{text.close}}</button>\n        </div>\n    </div>\n    <div *ngIf=\"hasArrow\"\n         [class.hide]=\"hideOther\">\n        <svg version=\"1.1\"\n             xmlns=\"http://www.w3.org/2000/svg\"\n             width=\"100%\"\n             height=\"100%\">\n            <defs>\n                <marker id=\"wkt-arrow\"\n                        viewBox=\"0 0 10 10\"\n                        refX=\"8\"\n                        refY=\"5\"\n                        markerUnits=\"strokeWidth\"\n                        orient=\"auto\"\n                        markerWidth=\"10\"\n                        markerHeight=\"10\">\n                    <polyline points=\"0,0 10,5 0,10 5,5\"\n                              stroke-width=\"0\"\n                              [attr.fill]=\"arrowColor || '#FFF'\" />\n                </marker>\n            </defs>\n            <path class=\"wkt-arrow-path\"\n                  [attr.d]=\"arrowPath\"\n                  [attr.stroke]=\"arrowColor || '#FFF'\"\n                  [attr.marker-end]=\"markerUrl\" />\n        </svg>\n    </div>\n</div>\n",
                    styles: [":host{display:block;position:absolute;z-index:1;top:0;left:0;width:99.9%;min-height:100%}:host.hide{display:none}:host.cursor{cursor:pointer}:host.backdrop{background-color:rgba(0,0,0,.6)}button{background:none;border:0;color:#fff}.wkt-zone{position:absolute}.wkt-zone.hide{display:none}.wkt-zone.backdrop{box-shadow:0 0 0 2200px rgba(0,0,0,.6)}.wkt-zone.glow{box-shadow:0 0 4px 2px #ff6,0 0 9px 0 #ff6,0 0 36px #ff6}.wkt-zone.clickable{cursor:pointer}.wkt-zone.highlight{-webkit-animation:highlight .45s 4;animation:highlight .45s 4}.wkt-container{position:relative}.wkt-content-block{position:absolute;margin:1em;padding:6px;z-index:1;color:#fff;min-width:calc(320px - 2em)}.wkt-content-block.hide{display:none}.wkt-content-block.darken{background-color:rgba(0,0,0,.6)}.wkt-close+.wkt-content{margin-top:1.3em}.wkt-close{position:absolute;right:1em;cursor:pointer}.wkt-navigate{display:flex;flex-wrap:wrap;justify-content:center}.wkt-navigate>button{padding:6px;font-size:120%}.wkt-navigate>button:hover{cursor:pointer;text-decoration:underline}.wkt-previous-link:before{content:\"<< \"}.wkt-next-link:after{content:\" >>\"}div.hide{display:none}svg{overflow:visible;position:absolute;top:-1px;left:-1px;border:1px solid transparent}#wkt-arrow>path{stroke-width:0}.wkt-arrow-path{stroke-width:2px;fill:none}@-webkit-keyframes highlight{0%{background-color:none}50%{background-color:hsla(0,0%,100%,.8)}to{background-color:none}}@keyframes highlight{0%{background-color:none}50%{background-color:hsla(0,0%,100%,.8)}to{background-color:none}}@media screen and (min-height:1920px),screen and (min-width:1920px){.wkt-zone.backdrop{box-shadow:0 0 0 4400px rgba(0,0,0,.6)}}@media screen and (min-height:3840px),screen and (min-width:3840px){.wkt-zone.backdrop{box-shadow:0 0 0 8800px rgba(0,0,0,.6)}}.wkt-zone.backdrop,_:default:not(:root:root){box-shadow:0 0 0 2000px rgba(0,0,0,.6)!important}"]
                },] }
    ];
    /** @nocollapse */
    WalkthroughContainerComponent.ctorParameters = function () { return [
        { type: core.ViewContainerRef },
        { type: WalkthroughService },
        { type: core.Renderer2 },
        { type: core.ElementRef }
    ]; };
    WalkthroughContainerComponent.propDecorators = {
        _portalHost: [{ type: core.ViewChild, args: [portal.PortalHostDirective,] }],
        content: [{ type: core.ViewChild, args: ['content',] }],
        contentBlock: [{ type: core.ViewChild, args: ['contentBlock',] }],
        zone: [{ type: core.ViewChild, args: ['zone',] }],
        id: [{ type: core.HostBinding, args: ['attr.id',] }],
        hide: [{ type: core.HostBinding, args: ['class.hide',] }],
        cursor: [{ type: core.HostBinding, args: ['class.cursor',] }],
        backdrop: [{ type: core.HostBinding, args: ['class.backdrop',] }],
        click: [{ type: core.HostListener, args: ['click',] }]
    };

    var nextUniqueId = 0;
    var WalkthroughFlowComponent = /** @class */ (function () {
        function WalkthroughFlowComponent() {
            this.closed = new core.EventEmitter();
            this.finished = new core.EventEmitter();
            this.contentStyle = 'draken';
            this.marginZone = null;
            this._uid = "walkthrough-flow-" + nextUniqueId++;
        }
        Object.defineProperty(WalkthroughFlowComponent.prototype, "id", {
            get: function () { return this._id; },
            set: function (value) { this._id = value || this._uid; },
            enumerable: false,
            configurable: true
        });
        WalkthroughFlowComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            setTimeout(function () {
                _this.init();
            }, 0);
        };
        WalkthroughFlowComponent.prototype.init = function () {
            var _this = this;
            var prevComp = null;
            this.walkthroughComponents.forEach(function (walkthrough) {
                // navigation auto (ignore previousStep/nextStep on the WalkthroughComponent)
                if (prevComp) {
                    walkthrough.previousStep = prevComp;
                    prevComp.nextStep = walkthrough;
                }
                prevComp = walkthrough;
                // transmition (only if different from default)
                if (_this.closed) {
                    walkthrough.closed = _this.closed;
                }
                if (_this.finished) {
                    walkthrough.finished = _this.finished;
                }
                if (!walkthrough.contentStyle && _this.contentStyle) {
                    walkthrough.contentStyle = _this.contentStyle;
                }
                if (!walkthrough.arrowColor && _this.arrowColor) {
                    walkthrough.arrowColor = _this.arrowColor;
                }
                if (!walkthrough.marginZone && _this.marginZone) {
                    walkthrough.marginZone = _this.marginZone;
                }
                if (!walkthrough.showArrow && booleanValue(_this.showArrow)) {
                    walkthrough.showArrow = _this.showArrow;
                }
                if (!walkthrough.rootElement && _this.rootElement) {
                    walkthrough.rootElement = _this.rootElement;
                }
                if (!walkthrough.closeButton && booleanValue(_this.closeButton)) {
                    walkthrough.closeButton = _this.closeButton;
                }
                if (walkthrough.closeAnywhere && !booleanValue(_this.closeAnywhere)) {
                    walkthrough.closeAnywhere = _this.closeAnywhere;
                }
                if (!walkthrough.finishButton && booleanValue(_this.finishButton)) {
                    walkthrough.finishButton = _this.finishButton;
                }
                if (!walkthrough.focusBackdrop && booleanValue(_this.focusBackdrop)) {
                    walkthrough.focusBackdrop = _this.focusBackdrop;
                }
                if (!walkthrough.focusGlow && booleanValue(_this.focusGlow)) {
                    walkthrough.focusGlow = _this.focusGlow;
                }
                if (!walkthrough.radius && _this.radius) {
                    walkthrough.radius = _this.radius;
                }
                if (!walkthrough.texts && _this.texts) {
                    walkthrough.texts = _this.texts;
                }
            });
            // navigation auto (close on last step)
            prevComp.finishButton = true;
        };
        WalkthroughFlowComponent.prototype.start = function () {
            this.walkthroughComponents.first.open();
        };
        return WalkthroughFlowComponent;
    }());
    WalkthroughFlowComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'ng-walkthrough-flow',
                    template: ''
                },] }
    ];
    /** @nocollapse */
    WalkthroughFlowComponent.ctorParameters = function () { return []; };
    WalkthroughFlowComponent.propDecorators = {
        walkthroughComponents: [{ type: core.ContentChildren, args: [WalkthroughComponent,] }],
        id: [{ type: core.Input }],
        closed: [{ type: core.Output }],
        finished: [{ type: core.Output }],
        contentStyle: [{ type: core.Input }],
        arrowColor: [{ type: core.Input }],
        marginZone: [{ type: core.Input }],
        showArrow: [{ type: core.Input }],
        rootElement: [{ type: core.Input }],
        closeButton: [{ type: core.Input }],
        closeAnywhere: [{ type: core.Input }],
        finishButton: [{ type: core.Input }],
        focusBackdrop: [{ type: core.Input }],
        focusGlow: [{ type: core.Input }],
        radius: [{ type: core.Input }],
        texts: [{ type: core.Input }]
    };

    var WalkthroughModule = /** @class */ (function () {
        function WalkthroughModule() {
        }
        return WalkthroughModule;
    }());
    WalkthroughModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        portal.PortalModule
                    ],
                    declarations: [
                        WalkthroughFlowComponent,
                        WalkthroughComponent,
                        WalkthroughContainerComponent
                    ],
                    exports: [
                        WalkthroughFlowComponent,
                        WalkthroughComponent,
                        WalkthroughContainerComponent
                    ],
                    entryComponents: [
                        WalkthroughContainerComponent
                    ],
                    providers: [
                        WalkthroughService
                    ]
                },] }
    ];

    /*
     * Public API Surface of angular-walkthrough
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.WalkthroughComponent = WalkthroughComponent;
    exports.WalkthroughContainerComponent = WalkthroughContainerComponent;
    exports.WalkthroughEvent = WalkthroughEvent;
    exports.WalkthroughFlowComponent = WalkthroughFlowComponent;
    exports.WalkthroughMargin = WalkthroughMargin;
    exports.WalkthroughModule = WalkthroughModule;
    exports.WalkthroughService = WalkthroughService;
    exports.WalkthroughText = WalkthroughText;
    exports.booleanValue = booleanValue;
    exports.throwWalkthroughContentAlreadyAttachedError = throwWalkthroughContentAlreadyAttachedError;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=angular-walkthrough.umd.js.map
